#ECluster_IncludePath = "..\Include\Include\"
XIncludeFile "..\Include\Include\ECluster_inc.pbi"

ECluster_Init("..\Include\Windows\ECluster.dll")

*DB = ECluster_SQLite_Create("mydata.db")
ECluster_SQLite_UpdateSync(*DB, "CREATE TABLE FILEDATA (id INT, name VARCHAR(100), data BLOB)")

data1.s = "not compressed and not encrypted data..."
data2.s = "112233445566778899112233445566778899112233445566778899112233445566778899112233445566778899112233445566778899112233445566778899112233445566778899"

;Store data in the database
ECluster_SQLite_Query(*DB, "INSERT INTO FILEDATA (id, name, data) VALUES (?,?,?)")

;1. Row
ECluster_SQLite_StoreAsLong(*DB, 0, 11)
ECluster_SQLite_StoreAsString(*DB, 1, "file1")
ECluster_SQLite_StoreAsBlob(*DB, 2, @data1, Len(data1) + 1, #ECluster_SQLite_BLOB_DEFAULT)
ECluster_SQLite_StoreRow(*DB)

;2. Row
ECluster_SQLite_StoreAsLong(*DB, 0, 22)
ECluster_SQLite_StoreAsString(*DB, 1, "file2")
ECluster_SQLite_StoreAsBlob(*DB, 2, @data2, Len(data2) + 1, #ECluster_SQLite_BLOB_COMPRESSED)
ECluster_SQLite_StoreRow(*DB)

ECluster_SQLite_EndQuery(*DB)

; Read the data
ECluster_SQLite_Query(*DB, "SELECT * FROM FILEDATA")

While ECluster_SQLite_SelectRow(*DB, iCount)
  
  iID.i = ECluster_SQLite_GetAsLong(*DB, 0)
  sName.s = ECluster_SQLite_GetAsString(*DB, 1)
  *pData = ECluster_SQLite_GetAsBlobPointer(*DB, 2)
  Debug Str(iID) + ", " + sName + ", " + PeekS(*pData)
  ECluster_FreeMemory(*pData)
  
  iCount + 1
Wend
ECluster_SQLite_EndQuery(*DB)
ECluster_SQLite_Close(*DB)
; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 23
; EnableXP