
#ECluster_IncludePath = "..\Include\Include\"
XIncludeFile "..\Include\Include\ECluster_inc.pbi"

UseJPEGImageDecoder()

; Initialisieren
ECluster_Init("..\Include\Windows\ECluster.dll")

Global Log

Procedure AddLog(Text.s)
  AddGadgetItem(Log, 0, "[" + FormatDate("%hh:%ii:%ss", Date()) + "] " + Text)
EndProcedure

; Job CallBack
Procedure LogoLoader(EMaster, Slave, Job, Event, *Mem, MemSize, UserData)
  Protected Img
  If Event = #Event_Job_Finished
    Img = CatchImage(#PB_Any, *Mem)
    ECluster_FreeMemory(*Mem)
    SetGadgetState(UserData, ImageID(Img))
  EndIf
EndProcedure

Procedure StreamCB(Master, Slave, S1, S2, UserData)
  ;MessageRequester("", StrD((S2/S1)*100, 2))
  ProcedureReturn #True
EndProcedure

M1 = ECluster_Master_Init(6)
If M1
  ECluster_Master_ThreadReceive(M1, #True)
  ; Slave hinzufgen
  Slave = ECluster_Master_AddSlave(M1, "localhost", 444)
  If Slave
    *Mem = AllocateMemory(20*1024*1024)
    ECluster_Master_DoJob(M1, "StreamTest", Slave, 0, 0, 0, *Mem, 20*1024*1024, 256*1024, @StreamCB())
    ECluster_Master_DeInit(M1)
    FreeMemory(*Mem)
  EndIf
EndIf

; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 27
; Folding = -
; EnableXP