Procedure CopyImageToMem(Img, *mem)
  Protected bmi.BITMAPINFO
  Protected w, h
  
  w = ImageWidth(Img)
  h = ImageHeight(Img)
  
  bmi\bmiHeader\biSize = SizeOf(BITMAPINFOHEADER)
  bmi\bmiHeader\biWidth = w
  bmi\bmiHeader\biHeight = h
  bmi\bmiHeader\biPlanes = 1
  bmi\bmiHeader\biBitCount = ImageDepth(Img)
  bmi\bmiHeader\biCompression = #BI_RGB
  
  If GetDIBits_(StartDrawing(ImageOutput(Img)), ImageID(Img), 0, h, *mem, bmi, #DIB_RGB_COLORS)
    StopDrawing()
    ProcedureReturn #True
  Else
  StopDrawing()
  ProcedureReturn #False
EndIf
EndProcedure
;
; CreateImage(0, 1280, 1024)

; time = ElapsedMilliseconds()
;
; wi = ImageWidth(0)
; hi = ImageHeight(0)
;
; *buffer = AllocateMemory(wi*hi*4)
; CopyImageToMem(0, *buffer)
; time = ElapsedMilliseconds()-time
; MessageRequester("lol", Str(time))
; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 11
; Folding = -
; EnableXP