#ECluster_IncludePath = "..\Include\Include\"
XIncludeFile "..\Include\Include\ECluster_inc.pbi"

; Initialisieren
ECluster_Init("..\Include\Windows\ECluster.dll")
XIncludeFile "MD5_BF.pbi"

; StartPW.s = "zzzzz"
; StopPW.s = "zzzzzz"
CharSet.s = "abcdefghijklmnopqrstuvwxyz"
MD5.s = "453e41d218e071ccfb2d1c99ce23906a"

p1 = PWGen_Init("abcdefghijklmnopqrstuvwxyz")
Parts.s = PWGen_Part(p1, 6, 4)
PartCnt = CountString(Parts, ";")
OpenConsole()

t = ElapsedMilliseconds()
M1 = ECluster_Master_Init()
If M1
  Slave = ECluster_Master_AddSlave(M1, "localhost", 444)
  If Slave
    
    For i = 1 To PartCnt
      StartPW.s = StringField(Parts, i, ";")
      StopPW.s = StringField(Parts, i + 1, ";")
      Para = ECluster_Parameter_New()
      ECluster_Parameter_AddString(Para, CharSet)
      ECluster_Parameter_AddString(Para, StartPW)
      ECluster_Parameter_AddString(Para, StopPW)
      ECluster_Parameter_AddString(Para, MD5)
      Job = ECluster_Master_DoJob(M1, "MD5_BruteForce", Slave, Para)
      PrintN("MD5 BF Send " + Str(Job))
    Next
    Repeat
      ECluster_Master_WaitEvent(M1)
      While ECluster_Master_Event(M1)
        Select ECluster_Master_Event_Type(M1)
          Case #Event_Job_Received
            PrintN("Slave Received BF " + Str(ECluster_Master_Event_JobId(M1)))
            
          Case #Event_Job_inProgress
            PrintN("Slave Started BF " + Str(ECluster_Master_Event_JobId(M1)))
            
          Case #Event_Job_Finished
            PrintN("Slave Finished BF " + Str(ECluster_Master_Event_JobId(M1)))
            Result.s = ECluster_Master_Event_JobString(M1)
            If Result
              Ende = 1
              nTime.s = StrF((ElapsedMilliseconds()-t)/1000, 2)
            Else
              PrintN("PW Not found")
            EndIf
            
          Case #Event_Job_Unknown
            PrintN("Slave does not know BF")
            Result.s = "Fehler. Kein BF auf diesem Client mglich"
            Ende = 1
            
        EndSelect
      Wend
    Until Ende
    PrintN("Pw found: Result: " + Result)
    PrintN("Time needed: " + nTime + " sek")
    Input()
  EndIf
  ECluster_Master_DeInit(M1)
EndIf
; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 1
; EnableXP
; DisableDebugger